#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <errno.h>

#include "prefs.h"
#include "mrmacs.h"
#include "fparser.h"
#include "vxerror.h"
#include "tools.h"
#include "vxopt.h"
#include "exitcodes.h"

void usage (void)
{
    fprintf (stderr, "\nUsage; %s <filter>\n\n", progname);
    exit (1);
}

static char *vars[] = {
    "SENDER=bj@isv-gmbh.de",
    "SDOMAIN=isv-gmbh.de",
    "SUSER=bj",
    "RECIPIENT=bj@xyz.de",
    "RDOMAIN=xyz.de",
    "RUSER=bj",
    "TARGET=bj@xyz.de",
    "TDOMAIN=xyz.de",
    "TUSER=bj",
    NULL
};

int main (int argc, char *argv[])
{
    char *ff;
    FILE *fp;
    filter_t filt;
    vxopt (&argc, argv, usage);
    if (argc < 2) { usage(); }
    ff = argv[1];
    ifnull (fp = fopen (ff, "r")) {
	vxerror_at (EX_OSERR, errno, __FILE__, __LINE__,
		    "attempt to open file `%s' failed", ff);
    }
    ifnull (filt = fparser (fp, vars)) {
	vxerror_at (EX_SOFTWARE, 0, __FILE__, __LINE__,
		    "filter parser failed.\n");
    }
    printf ("Filter parser succeeded!\n");
    return 0;
}
