#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <sys/types.h>

#include "config.h"
#include "mrmacs.h"

const char *qtrans (const char *string) {
    static char res[1024];
    char *p;
    for (p = res; *string; ++string) {
	if (*string == '"') {
	    if (p - res >= 1022) { break; }
	    *p++ = '\\'; *p++ = *string;
	} else {
	    if (p - res >= 1023) { break; }
	    *p++ = *string;
	}
    }
    *p = '\0';
    return res;
}
	    
int main (int argc, char *argv[])
{
    if (argc < 2) {
	printf ("CONFIGFILE \"%s\"\n", CONFIGFILE);
	ifnull (USERDB_NAME) {
	    printf ("USERDB_NAME NULL\n");
	} else {
	    printf ("USERDB_NAME \"%s\"\n", (char *) USERDB_NAME);
	}
	ifnull (DBIF_DEFMOD) {
	    printf ("DBIF_DEFMOD NULL\n");
	} else {
	    printf ("DBIF_DEFMOD \"%s\"\n", (char *) DBIF_DEFMOD);
	}
	printf ("LISTDIR \"%s\"\n", LISTDIR);
	printf ("RXDIR \"%s\"\n", RXDIR);
	if (NONLOCALTO != NULL) {
	    printf ("NONLOCALTO \"%s\"\n", NONLOCALTO);
	} else {
	    printf ("NONLOCALTO ((char *) NULL\n");
	}
	printf ("STD_FPERM 0%o\n", STD_FPERM);
	printf ("BODY_IN_REJECTED_MAILS %d\n", BODY_IN_REJECTED_MAILS);
	printf ("LISTEN_TO %d\n", LISTEN_TO);
	printf ("MAX_LISTEN %d\n", MAX_LISTEN);
	printf ("TMPDIR \"%s\"\n", TMPDIR);
	printf ("VXPOPPIDFILE \"%s\"\n", VXPOPPIDFILE);
	printf ("VXPOP_CLITIMEOUT %d\n", VXPOP_CLITIMEOUT);
	printf ("VXPOP_SENDTIMEOUT %d\n", VXPOP_SENDTIMEOUT);
	printf ("REDIR_TIMEOUT %d\n", REDIR_TIMEOUT);
	printf ("POP3SERVICE_NAME \"%s\"\n", POP3SERVICE_NAME);
	printf ("SMTPSERVICE_NAME \"%s\"\n", SMTPSERVICE_NAME);
	printf ("IMAPSERVICE_NAME \"%s\"\n", IMAPSERVICE_NAME);
	printf ("MSG_FIRSTLINE \"%s\"\n", MSG_FIRSTLINE);
	printf ("MSG_LASTLINE \"%s\"\n", MSG_LASTLINE);
	printf ("SYSAUTH %d\n", SYSAUTH);
	printf ("CHECK_SIZE %ld\n", CHECK_SIZE);
	printf ("CHECK_DAYS %d\n", CHECK_DAYS);
	printf ("DSIZECHECK %d\n", DSIZECHECK);
	printf ("COMPRESSION %d\n", COMPRESSION);
	printf ("LPERM 0%o\n", LPERM);
	printf ("TYPE_OF_DB %d\n", TYPE_OF_DB);
	printf ("MSG_DEFSCAN %d\n", MSG_DEFSCAN);
	printf ("LCUSER %d\n", LCUSER);
	printf ("LCDOMAIN %d\n", LCDOMAIN);
	printf ("MBOX_BASE \"%s\"\n", MBOX_BASE);
	if (REDIR_FNAME != NULL) {
	    printf ("REDIR_FNAME \"%s\"\n", REDIR_FNAME);
	} else {
	    printf ("REDIR_FNAME ((char *) NULL)\n");
	}
	printf ("SYSWITHIDX %d\n", SYSWITHIDX);
	printf ("MAXLEVEL %d\n", MAXLEVEL);
	printf ("REJVERB %d\n", REJVERB);
	printf ("DRACAUTH %d\n", DRACAUTH);
	printf ("BSMTP_NODOM %d\n", BSMTP_NODOM);
	printf ("IU_RECEIVES %d\n", IU_RECEIVES);
	printf ("BSMTP_TIMEOUT %d\n", BSMTP_TIMEOUT);
	printf ("TMPDIR \"%s\"\n", TMPDIR);
	printf ("ERRORSENDER \"%s\"\n", qtrans (ERRORSENDER));
	printf ("MAX_FOLDERSIZE %ld\n", MAX_FOLDERSIZE);
	printf ("POP3_AUTODELETE %d\n", POP3_AUTODELETE);
	printf ("SMTP_MAXCMDLEN %d\n", SMTP_MAXCMDLEN);
	printf ("SCHED_CMDFILE \"%s\"\n", SCHED_CMDFILE);
	printf ("SCHED_CHKT %d\n", SCHED_CHKT);
	printf ("SCHED_DELAY %d\n", SCHED_DELAY);
	printf ("SCHED_MAXFAILS %d\n", SCHED_MAXFAILS);
	printf ("POP3_ACCEPT_USER %d\n", POP3_ACCEPT_USER);
	printf ("POP3_PASS_FAILDELAY %d\n", POP3_PASS_FAILDELAY);
	printf ("DBIFATSESS %d\n", DBIFATSESS);
	printf ("DBIFATSERV %d\n", DBIFATSERV);
	printf ("DFLTLOGLVL %d\n", DFLTLOGLVL);
	printf ("DLVRDFLOGLVL %d\n", DLVRDFLOGLVL);
	printf ("POP3DFLOGLVL %d\n", POP3DFLOGLVL);
	return 0;
    }
    if (!strcmp (argv[1], "CONFIGFILE")) {
	printf ("%s\n", CONFIGFILE);
	return 0;
    }
    if (!strcmp (argv[1], "USERDB_NAME")) {
	printf ("%s\n", (isNULL(USERDB_NAME) ? "<<NULL>>" : USERDB_NAME));
	return 0;
    }
    if (!strcmp (argv[1], "DBIF_DEFMOD")) {
	printf ("%s\n", (isNULL(DBIF_DEFMOD) ? "<<NULL>>" : DBIF_DEFMOD));
	return 0;
    }
    if (!strcmp (argv[1], "LISTDIR")) {
	printf ("%s\n", LISTDIR);
	return 0;
    }
    if (!strcmp (argv[1], "RXDIR")) {
	printf ("%s\n", RXDIR);
	return 0;
    }
    if (!strcmp (argv[1], "NONLOCALTO")) {
	if (NONLOCALTO != NULL) {
	    printf ("\"%s\"\n", NONLOCALTO);
	} else {
	    printf ("((char *) NULL)\n");
	}
	return 0;
    }
    if (!strcmp (argv[1], "STD_FPERM")) {
	printf ("0%o\n", STD_FPERM);
	return 0;
    }
    if (!strcmp (argv[1], "BODY_IN_REJECTED_MAILS")) {
	printf ("%d\n", BODY_IN_REJECTED_MAILS);
	return 0;
    }
    if (!strcmp (argv[1], "LISTEN_TO")) {
	printf ("%d\n", LISTEN_TO);
	return 0;
    }
    if (!strcmp (argv[1], "MAX_LISTEN")) {
	printf ("%d\n", MAX_LISTEN);
	return 0;
    }
    if (!strcmp (argv[1], "TMPDIR")) {
	printf ("%s\n", TMPDIR);
	return 0;
    }
    if (!strcmp (argv[1], "VXPOPPIDFILE")) {
	printf ("%s\n", VXPOPPIDFILE);
	return 0;
    }
    if (!strcmp (argv[1], "VXPOP_CLITIMEOUT")) {
	printf ("%d\n", VXPOP_CLITIMEOUT);
	return 0;
    }
    if (!strcmp (argv[1], "VXPOP_SENDTIMEOUT")) {
	printf ("%d\n", VXPOP_SENDTIMEOUT);
	return 0;
    }
    if (!strcmp (argv[1], "REDIR_TIMEOUT")) {
	printf ("%d\n", REDIR_TIMEOUT);
	return 0;
    }
    if (!strcmp (argv[1], "POP3SERVICE_NAME")) {
	printf ("%s\n", POP3SERVICE_NAME);
	return 0;
    }
    if (!strcmp (argv[1], "SMTPSERVICE_NAME")) {
	printf ("%s\n", SMTPSERVICE_NAME);
	return 0;
    }
    if (!strcmp (argv[1], "IMAPSERVICE_NAME")) {
	printf ("%s\n", IMAPSERVICE_NAME);
	return 0;
    }
    if (!strcmp (argv[1], "MSG_FIRSTLINE")) {
	printf ("%s\n", MSG_FIRSTLINE);
	return 0;
    }
    if (!strcmp (argv[1], "MSG_LASTLINE")) {
	printf ("%s\n", MSG_LASTLINE);
	return 0;
    }
    if (!strcmp (argv[1], "MSG_DEFSCAN")) {
	printf ("%d\n", MSG_DEFSCAN);
    }
    if (!strcmp (argv[1], "SYSAUTH")) {
	printf ("%d\n", SYSAUTH);
	return 0;
    }
    if (!strcmp (argv[1], "CHECK_SIZE")) {
	printf ("%ld\n", CHECK_SIZE);
	return 0;
    }
    if (!strcmp (argv[1], "CHECK_DAYS")) {
	printf ("%d\n", CHECK_DAYS);
	return 0;
    }
    if (!strcmp (argv[1], "LPERM")) {
	printf ("0%o\n", LPERM);
	return 0;
    }
    if (!strcmp (argv[1], "TYPE_OF_DB")) {
	printf ("%d\n", TYPE_OF_DB);
	return 0;
    }
    if (!strcmp (argv[1], "MBOX_BASE")) {
	printf ("%s\n", MBOX_BASE);
	return 0;
    }
    if (!strcmp (argv[1], "REDIR_FNAME")) {
	printf ("%s\n", (REDIR_FNAME != NULL? REDIR_FNAME : "((char *) NULL)"));
	return 0;
    }
    if (!strcmp (argv[1], "DSIZECHECK")) {
	printf ("%d\n", DSIZECHECK);
	return 0;
    }
    if (!strcmp (argv[1], "COMPRESSION")) {
	printf ("%d\n", COMPRESSION);
	return 0;
    }
    if (!strcmp (argv[1], "LCUSER")) {
	printf ("%d\n", LCUSER);
	return 0;
    }
    if (!strcmp (argv[1], "LCDOMAIN")) {
	printf ("%d\n", LCDOMAIN);
	return 0;
    }
    if (!strcmp (argv[1], "SYSWITHIDX")) {
	printf ("%d\n", SYSWITHIDX);
	return 0;
    }
    if (!strcmp (argv[1], "MAXLEVEL")) {
	printf ("%d\n", MAXLEVEL);
	return 0;
    }
    if (!strcmp (argv[1], "REJVERB")) {
	printf ("%d\n", REJVERB);
	return 0;
    }
    if (!strcmp (argv[1], "DRACAUTH")) {
	printf ("%d\n", DRACAUTH);
	return 0;
    }
    if (!strcmp (argv[1], "BSMTP_NODOM")) {
	printf ("%d\n", BSMTP_NODOM);
	return 0;
    }
    if (!strcmp (argv[1], "IU_RECEIVES")) {
	printf ("%d\n", IU_RECEIVES);
	return 0;
    }
    if (!strcmp (argv[1], "BSMTP_TIMEOUT")) {
	printf ("%d\n", BSMTP_TIMEOUT);
	return 0;
    }
    if (!strcmp (argv[1], "TMPDIR")) {
	printf ("%s\n", TMPDIR);
    }
    if (!strcmp (argv[1], "ERRORSENDER")) {
	printf ("%s\n", ERRORSENDER);
    }
    if (!strcmp (argv[1], "MAX_FOLDERSIZE")) {
	printf ("%ld\n", MAX_FOLDERSIZE);
    }
    if (!strcmp (argv[1], "POP3_AUTODELETE")) {
	printf ("%d\n", POP3_AUTODELETE);
    }
    if (!strcmp (argv[1], "SMTP_MAXCMDLEN")) {
	printf ("%d\n", SMTP_MAXCMDLEN);
    }
    if (!strcmp (argv[1], "SCHED_CMDFILE")) {
	printf ("%s\n", SCHED_CMDFILE);
    }
    if (!strcmp (argv[1], "SCHED_CHKT")) {
	printf ("%d\n", SCHED_CHKT);
    }
    if (!strcmp (argv[1], "SCHED_DELAY")) {
	printf ("%d\n", SCHED_DELAY);
    }
    if (!strcmp (argv[1], "SCHED_MAXFAILS")) {
	printf ("%d\n", SCHED_MAXFAILS);
    }
    if (!strcmp (argv[1], "POP3_ACCEPT_USER")) {
	printf ("%d\n", POP3_ACCEPT_USER);
    }
    if (!strcmp (argv[1], "POP3_PASS_FAILDELAY")) {
	printf ("%d\n", POP3_PASS_FAILDELAY);
    }
    if (!strcmp (argv[1], "DBIFATSESS")) {
	printf ("%d\n", DBIFATSESS);
    }
    if (!strcmp (argv[1], "DBIFATSERV")) {
	printf ("%d\n", DBIFATSERV);
    }
    if (!strcmp (argv[1], "DFLTLOGLVL")) {
	printf ("%d\n", DFLTLOGLVL);
    }
    if (!strcmp (argv[1], "DLVRDFLOGLVL")) {
	printf ("%d\n", DLVRDFLOGLVL);
    }
    if (!strcmp (argv[1], "POP3DFLOGLVL")) {
	printf ("%d\n", POP3DFLOGLVL);
    }
    return 0;
}
